/******************************************************************************/
/*	aisa06s.c																  */
/*																			  */
/*	aISA-A06W/H															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/05/12															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa06w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szA06[] = _T("aISA-A06");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwVxdVer;
	BOOL  bResult;			// 
	WORD  wLogSlot;			// foCXi[
	AISA06RESOURCE ri;		// \[X
	WORD  i;
	WORD  wDaData;			// D/A݃f[^
	DWORD dwCH1;			// CH1̏
	DWORD dwCH2;			// CH2̏

/*---------------------------------------------------------------------------*/
	// aisa06.dll ̎gp錾
	if (Aisa06wDllOpen() == FALSE)
	{
		ErrorMessage(AISA06_SLOT_AUTO);
		return 1;			// aisa06.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-A06W/H DLL,VxD̃o[Wԍ擾
	if (Aisa06wGetVersion(&dwDLLVer, &dwVxdVer) == FALSE)
	{
		ErrorMessage(AISA06_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Vxd Version: %08lxh"),
					dwDLLVer,
					dwVxdVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A06W/H̎gp錾
	wLogSlot = AISA06_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa06wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							 NULL,		// wLogSlot ȊÖɂ́ANULL ܂ 0 ZbgĂB
							 0,
							 NULL);

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA06_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-A06W/H Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa06wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh"),
					szA06,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// o̓f[^̐ݒ
	wDaData = 0x0FFF;

	// gp{[h aISA-A06H ̏ꍇAŌ 2`lւ̏o͖͂܂B
	for (i = 0; i < AISA06_MAX_CH_W; i++)
		if (Aisa06wSetData(wLogSlot, i, wDaData) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

	ResultMessage(_T("o̓f[^ݒ肵܂B"));

/*---------------------------------------------------------------------------*/
	// O͏Ԃ̎擾
	if (Aisa06wGetCH(wLogSlot, &dwCH1, &dwCH2) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("O͏Ԃ̎擾\n")
					_T("CH1̏=%lxh\n")
					_T("CH2̏=%lxh"),
					dwCH1, dwCH2);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A06W/H̎gpJ
	if (Aisa06wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A06W/H Closed"));

/*---------------------------------------------------------------------------*/
	// aisa06.dll ̎gpJ
	if (Aisa06wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa06.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa06wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA06_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-A06W/H error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
